<template>
  <view class="page-picking-order">
    <view class="header">
      <view class="left">
        <u-icon class="icon" name="arrow-left" @click="index" />
      </view>
      <view class="title">{{ $t("message.Pi_ByOrderPicking") }}</view>
      <view class="right"></view>
    </view>
    <view class="table-wrapper">
      <wyb-table
        class="table"
        ref="table"
        width="100%"
        enable-check="single"
        show-left-and-right-border
        :headers="headers"
        :contents="model.orderList"
        :show-vert-border="false"
        @onCheck="handleRow"
      ></wyb-table>
    </view>
    <!-- 列表展示数据 -->
    <view class="Exhibition">
      <view class="Exhibition-left">
        <view class="Exhibition-left-title">工位:</view>
        <view class="Exhibition-left-data">{{ some.sendSpot }}</view>
      </view>
      <view class="Exhibition-right">
        <view class="Exhibition-right-title">已拣数量:</view>
        <view class="Exhibition-right-data">{{ some.totalMoAmount }}</view>
      </view>
    </view>
    <!-- 添加库位 -->
    <view class="library">
      <view class="library-left">
        <view>库位:</view>
        <jPicker
          sureColor="#ff0000"
          style="width: 230rpx"
          @bindpicker="LocationChoice"
          showKey="value"
          valKey="value"
          :val="wlCode"
          class="search"
          :options="Location"
        />
      </view>
      <view class="library-right">
        <view class="library-right-title">本次数量</view>
        <u-input v-model="qty" :type="type" :border="border" class="input" />
      </view>
    </view>
    <!-- 添加 -->
    <view class="add">
      <u-button type="primary" @click="Add">添加</u-button>
    </view>
    <!-- 表格 -->
    <u-table class="library-table">
      <u-tr class="u-tr">
        <u-th class="u-th">{{ $t("message.product_Location") }}</u-th>
        <u-th class="u-th">{{ $t("message.product_Number") }}</u-th>
        <u-th class="u-th">{{ $t("message.operation") }}</u-th>
      </u-tr>
      <u-tr class="u-tr" v-for="(item, index) in LocationList" :key="index">
        <u-td class="u-td">{{ item.wlCode }}</u-td>
        <u-td class="u-td">{{ item.qty }}</u-td>
        <u-td class="u-td">
          <div class="u-td" @click="deleteItem(index)">
            {{ $t("message.product_Delete") }}
          </div>
        </u-td>
      </u-tr>
    </u-table>
    <view class="bottom-bar">
      <div class="extra">
        <u-form ref="form" :model="form" :error-type="['toast']">
          <u-row class="bottom-info"> </u-row>
        </u-form>
      </div>
      <div class="container">
        <u-row>
          <u-col :span="4">
            <u-button type="primary" class="appoint" @click="appoint"
              >拣配明细</u-button
            >
          </u-col>
          <u-col :span="4">
            <u-button type="success" @click="onSubmit"> 提交 </u-button>
          </u-col>
          <u-col :span="4">
            <u-button type="error" @click="onUpload"> 返回 </u-button>
          </u-col>
        </u-row>
      </div>
    </view>
  </view>
</template>

<script lang="ts">
import { Component, Ref } from "vue-property-decorator";
import { BasePage } from "@/components/base/page";
import model from "./model";
import { orderHeaders } from "./config";
import { session } from "@/store/modules/session";
import { VForm, VFormRules } from "vue/types/form";
import jPicker from "@/components/J-Picker/jPicker.vue";
import { pick } from "lodash/fp";
@Component({
  components: {
    jPicker,
  },
})
export default class RawReceiptDetail extends BasePage {
  /**
   * 表单引用
   */
  @Ref("form") readonly $form!: VForm;
  @Ref("submitForm") readonly $submitForm!: VForm;
  submitForm = {
    receiver: "",
    receiverName: "",
    password: "",
  };
  /**
   * 页面Module
   */
  model = model;
  type = "text";
  wlCode: any = "";
  border = true;
  //添加库位和数量的列表
  LocationList: any = [];
  //库位
  Location: any = [];
  someIndex: number = 0;
  some: any = {};
  qty: any = "";
  /**
   * 表单数据
   */
  form: any = {
    // locationCode: null,
    amount: null,
  };
  index() {
    this.toPage(this.page.raw.handover.picking.result);
  }
  /**
   * 表单校验
   */
  rules: VFormRules<any> = {
    // locationCode: [{ required: true, message: '请选择库存地点！' }],
    amount: [
      { required: true, message: this.$t("message.Pi_tip1") as string },
      // { type: 'integer', min: 1, transform: Number, message: this.$t('message.Pi_tip2') as string },
    ],
  };

  /**
   * 库存地点选择
   */
  locationCodeSelect = false;

  /**
   * 表头
   */
  headers = orderHeaders;
  LocationChoice(e: any) {
    console.log("e>>>>>>>>>>>>>>>>>>>>>>>>", e);
    this.wlCode = e.pickerName;
  }
  handleRow({ data }: any) {
    this.someIndex = data[0].index;
    this.some = data[0].lineData;
    this.model.orderList[this.someIndex].wlList = [];
    this.model.orderList[this.someIndex].currentAmount = 0;
  }
  Add() {
    if (this.qty == "" || this.wlCode == "") {
      uni.showToast({
        icon: "none",
        title: "请输入正确的库位和数量" as any,
      });
      return;
    }
    if (parseFloat(this.qty) <= 0) {
      uni.showToast({
        icon: "none",
        title: "请输入大于0的数量" as any,
      });
      return;
    }
    if (parseFloat(this.qty) > model.orderList[this.someIndex].amount) {
      uni.showToast({
        icon: "none",
        title: "不能大于需求数量，请重新输入" as any,
      });
      return;
    }
    let num = parseFloat(this.qty);
    this.LocationList.forEach((item: any) => {
      num += parseFloat(item.qty);
    });
    console.log(num);
    if (num > this.model.orderList[this.someIndex].amount) {
      uni.showToast({
        icon: "none",
        title: "不能大于需求数量，请重新输入" as any,
      });
      return;
    }
    let isTrue: boolean = true;
    if (this.LocationList.length != 0) {
      this.LocationList.forEach((item: any) => {
        if (this.wlCode.sendSpot != item.Code) {
          uni.showToast({
            icon: "none",
            title: "请选择正确的库位" as any,
          });
          return (isTrue = false);
        }
      });
    }
    if (this.some == {}) {
      uni.showToast({
        icon: "none",
        title: "请先选择一个物料" as any,
      });
      return;
    }
    if ((isTrue = true)) {
      let arr = {
        wlCode: this.wlCode.label,
        qty: this.qty,
        Code: this.wlCode.sendSpot,
      };
      this.LocationList.push(arr);
      let objString = JSON.stringify(this.some);
      let TEM = JSON.parse(objString);
      TEM.wlList = null;
      TEM.wlCode = this.wlCode.label;
      TEM.hvAmount = this.qty;
      this.model.orderList[this.someIndex].wlList.push(TEM);
      this.model.orderList[this.someIndex].hvAmount += parseFloat(this.qty);
      console.log("this.model.orderList", this.model.orderList[this.someIndex]);
      this.qty = "";
    }
  }
  deleteItem(index: any) {
    this.LocationList.splice(index, 1);
    this.model.orderList[this.someIndex].wlList.splice(index, 1);
    this.business();
  }
  business() {
    let num: number = 0;
    this.LocationList.forEach((item: any) => {
      num += parseFloat(item.qty);
    });
    this.model.orderList[this.someIndex].currentAmount = num;
    console.log("this.model.orderList", this.model.orderList[this.someIndex]);
  }
  async onShow() {
    //页面初始化 获取可选库位
    let means: any = JSON.parse(
      localStorage.getItem("__GWMS_APP_STATE_DATA__") as any
    );
    let sendSpot = JSON.parse(localStorage.getItem("sendSpot") as any);
    let content = {
      loginName: means.session.user.loginName,
      sendSpot: sendSpot,
      factoryCode: means.session.user.factoryCode,
      workArea: session.workareaCode,
    };
    let res: any = await this.model.queryByFactoryCodeAndWorkAreaCode(content);
    res.forEach((item: any) => {
      let pickerName: any = {};
      pickerName.label = item.locationCode;
      pickerName.value = item.locationCode + "(" + item.sendSpot + ")";
      pickerName.sendSpot = item.sendSpot;
      this.Location.push(pickerName);
    });
    this.model.orderList.forEach((item: any) => {
      item.hvAmount = 0;
    });
  }
  appoint() {}

  /**
   * 提交
   */
  async onSubmit() {
    await model.uploadOrderList({
      operatorPass: this.submitForm.receiver,
      factoryCode: session.factoryCode,
      loginName: session.loginName,
      orderOutIdAmountList: model.orderList.map((item) => ({
        ...pick(
          [
            "materialCode",
            "amount",
            "totalHvAmount",
            "sapFactoryCode",
            "sendSpot",
            "materialDesc",
            "mrpCode",
            "unit",
            "prdOrder",
            "proType",
            "wkposCode",
            "hvAmount",
            "orderOutId",
            "wlList",
          ],
          item
        ),
        pickNum: item.totalMoAmount,
        factoryCode: session.factoryCode,
      })),
    });
  }
}
</script>

<style lang="scss" scoped>
.page-picking-order {
  background: #f2f2f2
    linear-gradient(0deg, #f2f2f2 0%, #4a78ea 51%, #1753ea 100%) no-repeat;
  background-size: 100% 600rpx;
  padding: 30rpx;
  min-height: 100%;
  padding-top: 118rpx;
  padding-bottom: 222rpx;

  .header {
    position: fixed;
    top: 36rpx;
    left: 0;
    right: 0;
    display: flex;
    height: 88rpx;
    line-height: 88rpx;
    color: #fff;
    font-size: 34rpx;
    font-weight: 500;
    text-align: center;
    .title {
      flex: 3;
    }
    .left,
    .right {
      flex: 1;
    }
    .icon {
      display: flex;
      justify-content: center;
      align-items: center;
      width: 88rpx;
      height: 88rpx;
    }
  }

  .table-wrapper {
    background-color: #fff;
    height: 500rpx;
    overflow-x: auto;
  }

  .form {
    background-color: #fff;
    padding: 40rpx;
    border-radius: 10rpx;
  }
  .Exhibition {
    width: 100%;
    height: 100rpx;
    margin-top: 20rpx;
    display: flex;
    .Exhibition-left {
      width: 50%;
      height: 100%;
      display: flex;
      .Exhibition-left-title {
        width: 50%;
        height: 100%;
        text-align: center;
        line-height: 100rpx;
      }
      .Exhibition-left-data {
        width: 50%;
        height: 100%;
        text-align: center;
        line-height: 100rpx;
      }
    }
    .Exhibition-right {
      width: 50%;
      height: 100%;
      display: flex;
      .Exhibition-right-title {
        width: 50%;
        height: 100%;
        text-align: center;
        line-height: 100rpx;
      }
      .Exhibition-right-data {
        width: 50%;
        height: 100%;
        text-align: center;
        line-height: 100rpx;
      }
    }
  }
  .library {
    width: 100%;
    height: 100rpx;
    display: flex;
    .library-left {
      width: 50%;
      height: 100%;
      display: flex;
      view {
        width: 230rpx;
        line-height: 100rpx;
        text-align: center;
      }
    }
    .library-right {
      width: 50%;
      height: 100%;
      display: flex;
      .library-right-title {
        width: 120rpx;
        height: 100%;
        line-height: 100rpx;
      }
      .input {
        width: 200rpx;
        height: 70rpx;
        margin-top: 15rpx;
        margin-left: 15rpx;
      }
    }
  }
  .add {
    width: 100%;
    height: 100rpx;
    position: relative;
    button {
      position: absolute;
      top: 10rpx;
      right: 20rpx;
    }
  }
  .bottom-bar {
    z-index: 21;
    position: fixed;
    bottom: 0;
    left: 0;
    right: 0;

    .container {
      background: #ffffff;
      box-shadow: 0 1rpx 20rpx 0 rgba(128, 128, 128, 0.2);
      padding: 20rpx;
    }

    .extra {
      background-color: #fff;
      margin: 5px;
      border-radius: 5px;
      padding: 0 10px;
    }

    .bottom-info {
      .u-form-item {
        padding: 0;
      }
    }
  }
}
</style>
